## libedlib 1.2.3

=== bindings/python/Makefile ===
default: build

############### FILES #################
FILES=edlib pyedlib.bycython.cpp setup.py MANIFEST.in README.rst

edlib: ../../edlib
	cp -R ../../edlib .

pyedlib.bycython.cpp: edlib.pyx cedlib.pxd
	cython --cplus edlib.pyx -o edlib.bycython.cpp
#######################################

############## COMMANDS ###############
build: ${FILES}
	python setup.py build_ext -i

sdist: ${FILES}
	python setup.py sdist

publish: clean sdist
	twine upload dist/*

clean:
	rm -rf edlib dist edlib.egg-info build
	rm -f edlib.c *.bycython.* edlib.*.so
#######################################

=== debian/changelog ===
libedlib (1.2.3-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Fix test
  * Drop symbols file for backports to simplify build

 -- Andreas Tille <tille@debian.org>  Sun, 21 Oct 2018 07:51:18 +0200

libedlib (1.2.3-3) unstable; urgency=medium

  * Fix Vcs fields

 -- Andreas Tille <tille@debian.org>  Fri, 19 Oct 2018 09:13:39 +0200

libedlib (1.2.3-2) unstable; urgency=medium

  * Fix symbols file
    Closes: #905386
  * Standards-Version: 4.2.1
  * Run build time tests
  * Add autopkgtest

 -- Andreas Tille <tille@debian.org>  Fri, 19 Oct 2018 08:15:14 +0200

libedlib (1.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #901184)

 -- Andreas Tille <tille@debian.org>  Sun, 10 Jun 2018 00:21:35 +0200

=== debian/control ===
Source: libedlib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               d-shlibs,
               rename
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/libedlib
Vcs-Git: https://salsa.debian.org/med-team/libedlib.git
Homepage: https://github.com/Martinsos/edlib

Package: libedlib0
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: library for sequence alignment using edit distance
 A lightweight and super fast C/C++ library for sequence alignment using
 edit distance.
 .
 Calculating edit distance of two strings is as simple as:
 .
  edlibAlign("hello", 5, "world!", 6,
             edlibDefaultAlignConfig()).editDistance;
 Features
 .
  * Calculates edit distance (Levehnstein distance).
  * It can find optimal alignment path (instructions how to transform
    first sequence into the second sequence).
  * It can find just the start and/or end locations of alignment path -
    can be useful when speed is more important than having exact
    alignment path.
  * Supports multiple alignment methods: global(NW), prefix(SHW) and
    infix(HW), each of them useful for different scenarios.
  * You can extend character equality definition, enabling you to e.g.
    have wildcard characters, to have case insensitive alignment or to
    work with degenerate nucleotides.
  * It can easily handle small or very large sequences, even when finding
    alignment path, while consuming very little memory.
  * Super fast thanks to Myers's bit-vector algorithm.
 .
 This package contains the shared library.

Package: libedlib-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libedlib0 (= ${binary:Version})
Description: library for sequence alignment using edit distance (devel)
 A lightweight and super fast C/C++ library for sequence alignment using
 edit distance.
 .
 Calculating edit distance of two strings is as simple as:
 .
  edlibAlign("hello", 5, "world!", 6,
             edlibDefaultAlignConfig()).editDistance;
 Features
 .
  * Calculates edit distance (Levehnstein distance).
  * It can find optimal alignment path (instructions how to transform
    first sequence into the second sequence).
  * It can find just the start and/or end locations of alignment path -
    can be useful when speed is more important than having exact
    alignment path.
  * Supports multiple alignment methods: global(NW), prefix(SHW) and
    infix(HW), each of them useful for different scenarios.
  * You can extend character equality definition, enabling you to e.g.
    have wildcard characters, to have case insensitive alignment or to
    work with degenerate nucleotides.
  * It can easily handle small or very large sequences, even when finding
    alignment path, while consuming very little memory.
  * Super fast thanks to Myers's bit-vector algorithm.
 .
 This package contains the static library and the header files.

Package: edlib-aligner
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libedlib0 (= ${binary:Version})
Description: edlib sequence alignment tool using edit distance
 Edlib is a lightweight and super fast C/C++ library for sequence
 alignment using edit distance.  This package provides an aligner
 using this library.
 .
 Features of libedlib
 .
  * Calculates edit distance (Levehnstein distance).
  * It can find optimal alignment path (instructions how to transform
    first sequence into the second sequence).
  * It can find just the start and/or end locations of alignment path -
    can be useful when speed is more important than having exact
    alignment path.
  * Supports multiple alignment methods: global(NW), prefix(SHW) and
    infix(HW), each of them useful for different scenarios.
  * You can extend character equality definition, enabling you to e.g.
    have wildcard characters, to have case insensitive alignment or to
    work with degenerate nucleotides.
  * It can easily handle small or very large sequences, even when finding
    alignment path, while consuming very little memory.
  * Super fast thanks to Myers's bit-vector algorithm.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_install:
	dh_install
	file-rename 's/_static\.a/.a/' `find debian -name libedlib_static.a`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*.so

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	`find . -name edlib-aligner -type f` -p apps/aligner/test_data/query.fasta apps/aligner/test_data/target.fasta
	`find . -name runTests`
endif

## libedlib 1.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
project(edlib)

set(MACOSX (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))

if(CMAKE_BUILD_TYPE MATCHES Debug)
  message("Debug mode")
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)  # Falling back to different standard it not allowed.
set(CMAKE_CXX_EXTENSIONS NO)  # Make sure no compiler-specific features are used.

# Set strict warnings.
if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
else()
  message("Setting warning flags")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
endif()

# Define output directories for created binaries and libraries.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

file(GLOB SOURCES "edlib/src/*.cpp")

# Create libraries.
add_library(edlib SHARED ${SOURCES})

target_include_directories(edlib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/edlib/include>
    $<INSTALL_INTERFACE:include>)

add_library(edlib_static STATIC ${SOURCES})

target_include_directories(edlib_static PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/edlib/include>
    $<INSTALL_INTERFACE:include>)

# Build binaries.
add_executable(helloWorld apps/hello-world/helloWorld.c)
target_link_libraries(helloWorld edlib_static)

add_executable(runTests test/runTests.cpp)
target_link_libraries(runTests edlib_static)

if (NOT WIN32) # If on windows, do not build binaries that do not support windows.
  add_executable(edlib-aligner apps/aligner/aligner.cpp)
  target_link_libraries(edlib-aligner edlib_static)
endif()


# Create target 'install' for installing libraries.
install(TARGETS edlib edlib_static DESTINATION lib)
install(FILES edlib/include/edlib.h DESTINATION include)

=== debian/changelog ===
libedlib (1.2.4-2ubuntu1) focal; urgency=medium

  * Mark some symbols as optional.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2020 12:01:33 +0100

libedlib (1.2.4-2build2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:22 +0100

libedlib (1.2.4-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:41:18 +0000

libedlib (1.2.4-2) unstable; urgency=medium

  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Set upstream metadata fields: Name.
  * Adapt symbols file to gcc9
    Closes: #925740

 -- Andreas Tille <tille@debian.org>  Sun, 18 Aug 2019 15:49:41 +0200

libedlib (1.2.4-1) unstable; urgency=medium

  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Mon, 28 Jan 2019 19:11:07 +0100

libedlib (1.2.3-5) unstable; urgency=medium

  * Declare characters signed explicitly
    Closes: #911967

 -- Andreas Tille <tille@debian.org>  Wed, 19 Dec 2018 12:50:07 +0100

libedlib (1.2.3-4) unstable; urgency=medium

  * Make sure the executable is found in test
  * Add Python3 bindings

 -- Andreas Tille <tille@debian.org>  Mon, 17 Dec 2018 08:59:56 +0100

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,15 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
+               dh-python,
                d-shlibs,
-               rename
-Standards-Version: 4.2.1
+               rename,
+               cython3,
+               python3-all-dev,
+               python3-setuptools
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/libedlib
 Vcs-Git: https://salsa.debian.org/med-team/libedlib.git
 Homepage: https://github.com/Martinsos/edlib
@@ -103,3 +107,36 @@
   * It can easily handle small or very large sequences, even when finding
     alignment path, while consuming very little memory.
   * Super fast thanks to Myers's bit-vector algorithm.
+
+Package: python3-edlib
+Architecture: any
+Section: python
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         ${python3:Depends}
+Description: library for sequence alignment using edit distance (Python3 module)
+ A lightweight and super fast C/C++ library for sequence alignment using
+ edit distance.
+ .
+ Calculating edit distance of two strings is as simple as:
+ .
+  edlibAlign("hello", 5, "world!", 6,
+             edlibDefaultAlignConfig()).editDistance;
+ Features
+ .
+  * Calculates edit distance (Levehnstein distance).
+  * It can find optimal alignment path (instructions how to transform
+    first sequence into the second sequence).
+  * It can find just the start and/or end locations of alignment path -
+    can be useful when speed is more important than having exact
+    alignment path.
+  * Supports multiple alignment methods: global(NW), prefix(SHW) and
+    infix(HW), each of them useful for different scenarios.
+  * You can extend character equality definition, enabling you to e.g.
+    have wildcard characters, to have case insensitive alignment or to
+    work with degenerate nucleotides.
+  * It can easily handle small or very large sequences, even when finding
+    alignment path, while consuming very little memory.
+  * Super fast thanks to Myers's bit-vector algorithm.
+ .
+ This package contains the Python3 module.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export PYBUILD_NAME = edlib

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	# $(MAKE) --directory=bindings/python
	$(MAKE) --directory=bindings/python edlib pyedlib.bycython.cpp
	dh_auto_build --buildsystem=pybuild -- --dir bindings/python

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
#	$(MAKE) install --directory=bindings/python
	dh_auto_install --buildsystem=pybuild -- --dir bindings/python

override_dh_install:
	dh_install
	file-rename 's/_static\.a/.a/' `find debian -name libedlib_static.a`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    debian/tmp/usr/lib/*.so

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	`find . -name edlib-aligner -type f -executable` -p apps/aligner/test_data/query.fasta apps/aligner/test_data/target.fasta
	`find . -name runTests`
endif

## libedlib 1.2.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
project(edlib VERSION 1.2.5)

set(MACOSX (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))

if(CMAKE_BUILD_TYPE MATCHES Debug)
  message("Debug mode")
endif()

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)  # Falling back to different standard it not allowed.
set(CMAKE_CXX_EXTENSIONS OFF)  # Make sure no compiler-specific features are used.

# Build edlib as static library by default
set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build all libraries as shared")

# Set strict warnings.
if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
else()
  message("Setting warning flags")

  check_cxx_compiler_flag(-Wold-style-cast WOLD_STYLE_CAST)
  if (WOLD_STYLE_CAST)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast")
  endif()
  check_cxx_compiler_flag(-Wshadow WSHADOW)
  if (WSHADOW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
endif()

# Define output directories for created binaries and libraries.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

file(GLOB SOURCES "edlib/src/*.cpp")

# Create libraries.
add_library(edlib ${SOURCES})
set_target_properties(edlib
    PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION})

target_include_directories(edlib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/edlib/include>
    $<INSTALL_INTERFACE:include>)

# Build binaries.
add_executable(helloWorld apps/hello-world/helloWorld.c)
target_link_libraries(helloWorld edlib)

include(CTest)
if (BUILD_TESTING)
  add_executable(runTests test/runTests.cpp)
  target_link_libraries(runTests edlib)

  add_test(edlib_tests ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/runTests)
endif()

if (NOT WIN32) # If on windows, do not build binaries that do not support windows.
  add_executable(edlib-aligner apps/aligner/aligner.cpp)
  target_link_libraries(edlib-aligner edlib)
endif()


# Create target 'install' for installing libraries.
install(TARGETS edlib DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES edlib/include/edlib.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# configure and install pkg-config file
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/edlib.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/edlib-1.pc
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/edlib-1.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
libedlib (1.2.6-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

  [ Steffen Moeller ]
  * Added refs to conda and omictools

  [ Nilesh Patra ]
  * Refresh patch
  * Enable building both shared and static lib
  * Modify d-shlibs for pkgconfig and gnuinstalldirs
  * Rename lib package as per package version

 -- Andreas Tille <tille@debian.org>  Tue, 12 Jan 2021 16:33:05 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                cython3,
                python3-all-dev,
                python3-setuptools
-Standards-Version: 4.4.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/libedlib
 Vcs-Git: https://salsa.debian.org/med-team/libedlib.git
 Homepage: https://github.com/Martinsos/edlib

=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,8 @@
 		    --devunversioned \
 		    --exclude-la \
 		    --movedev debian/tmp/usr/include/* usr/include \
-		    debian/tmp/usr/lib/*.so
+		    --movedev debian/tmp/usr/lib/*/pkgconfig usr/lib/$(DEB_HOST_MULTIARCH) \
+		    debian/tmp/usr/lib/*/*.so
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

## libedlib 1.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,9 @@
 cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
-project(edlib VERSION 1.2.5)
+project(edlib VERSION 1.2.6)
+
+option(EDLIB_ENABLE_INSTALL "Generate the install target" ON)
+option(EDLIB_BUILD_EXAMPLES "Build examples" ON)
+option(EDLIB_BUILD_UTILITIES "Build utilities" ON)
 
 set(MACOSX (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
 
@@ -10,7 +14,7 @@
 include(GNUInstallDirs)
 include(CheckCXXCompilerFlag)
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)  # Falling back to different standard it not allowed.
 set(CMAKE_CXX_EXTENSIONS OFF)  # Make sure no compiler-specific features are used.
 
@@ -48,18 +52,29 @@
 
 # Create libraries.
 add_library(edlib ${SOURCES})
+add_library(edlib::edlib ALIAS edlib)
 set_target_properties(edlib
-    PROPERTIES
+  PROPERTIES
+    CXX_VISIBILITY_PRESET hidden
+    VISIBILITY_INLINES_HIDDEN ON
     VERSION ${PROJECT_VERSION}
-    SOVERSION ${PROJECT_VERSION})
+    SOVERSION ${PROJECT_VERSION_MAJOR}
+)
+
+target_compile_definitions(edlib PRIVATE DLIB_BUILD)
+if(BUILD_SHARED_LIBS)
+  target_compile_definitions(edlib PUBLIC EDLIB_SHARED)
+endif()
 
 target_include_directories(edlib PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/edlib/include>
-    $<INSTALL_INTERFACE:include>)
+    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
 
 # Build binaries.
-add_executable(helloWorld apps/hello-world/helloWorld.c)
-target_link_libraries(helloWorld edlib)
+if(EDLIB_BUILD_EXAMPLES)
+  add_executable(helloWorld apps/hello-world/helloWorld.c)
+  target_link_libraries(helloWorld edlib)
+endif()
 
 include(CTest)
 if (BUILD_TESTING)
@@ -69,19 +84,63 @@
   add_test(edlib_tests ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/runTests)
 endif()
 
-if (NOT WIN32) # If on windows, do not build binaries that do not support windows.
-  add_executable(edlib-aligner apps/aligner/aligner.cpp)
-  target_link_libraries(edlib-aligner edlib)
+if(EDLIB_BUILD_UTILITIES)
+  if(NOT WIN32) # If on windows, do not build binaries that do not support windows.
+    add_executable(edlib-aligner apps/aligner/aligner.cpp)
+    target_link_libraries(edlib-aligner edlib)
+  endif()
 endif()
 
-
-# Create target 'install' for installing libraries.
-install(TARGETS edlib DESTINATION ${CMAKE_INSTALL_LIBDIR})
-install(FILES edlib/include/edlib.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-
 # configure and install pkg-config file
+set(PKG_EDLIB_DEFS "")
+get_target_property(EDLIB_INTERFACE_DEFS edlib INTERFACE_COMPILE_DEFINITIONS)
+if(NOT (EDLIB_INTERFACE_DEFS STREQUAL "NOTFOUND" OR EDLIB_INTERFACE_DEFS STREQUAL "EDLIB_INTERFACE_DEFS-NOTFOUND"))
+  foreach(EDLIB_INTERFACE_DEF ${EDLIB_INTERFACE_DEFS})
+    list(APPEND PKG_EDLIB_DEFS "-D${EDLIB_INTERFACE_DEF}")
+  endforeach()
+endif()
+string(REPLACE ";" " " PKG_EDLIB_DEFS "${PKG_EDLIB_DEFS}")
 configure_file(
     ${CMAKE_CURRENT_SOURCE_DIR}/edlib.pc.in
-    ${CMAKE_CURRENT_BINARY_DIR}/edlib-1.pc
+    ${CMAKE_CURRENT_BINARY_DIR}/edlib-${PROJECT_VERSION_MAJOR}.pc
     @ONLY)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/edlib-1.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
+if(EDLIB_ENABLE_INSTALL)
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/edlib-${PROJECT_VERSION_MAJOR}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+  include(CMakePackageConfigHelpers)
+  set(EDLIB_CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/edlib" CACHE STRING
+    "Installation directory for cmake files, relative to ${CMAKE_INSTALL_PREFIX}.")
+  set(version_config "${PROJECT_BINARY_DIR}/edlib-config-version.cmake")
+  set(project_config "${PROJECT_BINARY_DIR}/edlib-config.cmake")
+  set(targets_export_name edlib-targets)
+
+  # Generate the version, config and target files into the build directory.
+  write_basic_package_version_file(
+    ${version_config}
+    VERSION ${VERSION}
+    COMPATIBILITY AnyNewerVersion)
+  configure_package_config_file(
+    ${PROJECT_SOURCE_DIR}/edlib-config.cmake.in
+    ${project_config}
+    INSTALL_DESTINATION ${EDLIB_CMAKE_DIR})
+  export(TARGETS edlib NAMESPACE edlib::
+    FILE ${PROJECT_BINARY_DIR}/${targets_export_name}.cmake)
+
+  # Install version, config and target files.
+  # These are cmake config files and they are useful for some consumers, for example vcpkg.
+  install(
+    FILES ${project_config} ${version_config}
+    DESTINATION ${EDLIB_CMAKE_DIR})
+  install(EXPORT ${targets_export_name} DESTINATION ${EDLIB_CMAKE_DIR}
+    NAMESPACE edlib::)
+  
+  # Create target 'install' for installing libraries.
+  install(
+    TARGETS edlib
+    EXPORT ${targets_export_name} 
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  )
+  install(FILES edlib/include/edlib.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+endif()

=== Makefile ===
BUILD_DIR ?= meson-build
# Can be 'static' or 'shared'.
LIBRARY_TYPE ?= static
TEST_DATA_DIR ?= apps/aligner/test_data

YELLOW = \033[33m
GREEN  = \033[32m
BOLD   = \033[1m
RESET  = \033[0m

all:
	@printf "${YELLOW}${BOLD}Configuring build setup via Meson...${RESET}\n"
	${MAKE} configure
	@printf "\n${YELLOW}${BOLD}Building ${LIBRARY_TYPE} library and binaries...${RESET}\n"
	${MAKE} build
	@printf "\n${YELLOW}${BOLD}Running tests...${RESET}\n"
	${MAKE} test
	@printf "\n${GREEN}${BOLD}Edlib successfully built! You can find built binaries and libraries in ${BUILD_DIR}/ directory.${RESET}\n"

configure:
	rm -rf ${BUILD_DIR}
	meson setup ${BUILD_DIR} . \
		--backend=ninja \
    -Ddefault_library=${LIBRARY_TYPE}

build:
	meson compile -v -C ${BUILD_DIR}

test:
	meson test -v -C ${BUILD_DIR}

# Valgrind Returns 2 if there was a memory leak/error,
# otherwise returns runTests exit code, which is 0 if
# all went fine or 1 if some of the tests failed.
check-memory-leaks:
	valgrind ${BUILD_DIR}/runTests 2 \
    --quiet --error-exitcode=2 --tool=memcheck --leak-check=full

install:
	meson install -C ${BUILD_DIR}

clean:
	rm -rf ${BUILD_DIR}

.PHONY: all build configure test install clean check-memory-leaks

=== debian/changelog ===
libedlib (1.2.7-7) unstable; urgency=medium

  * cmake-4.patch: new: bump cmake requirement to 3.10. (Closes: #1113144)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/patches/*: normalise Last-Update timestamp.
  * fix-package-version.patch: provide a dep3 header.
  * d/watch: convert to v5 Github template.

 -- Étienne Mollier <emollier@debian.org>  Wed, 01 Oct 2025 20:16:10 +0200

libedlib (1.2.7-6) unstable; urgency=medium

  * d/libedlib1.symbols: mark symbols leaked by the compiler as optional.
    (Closes: #1015484, #1075164)
  * d/rules: always run LTO builds.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Sat, 13 Jul 2024 20:49:11 +0200

libedlib (1.2.7-5) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * d/clean: Remove generated files and folders from build (Closes: #1048671)

 -- Lance Lin <lq27267@gmail.com>  Mon, 26 Feb 2024 19:59:36 +0700

libedlib (1.2.7-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)
  * No tab in license text (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 19:51:17 +0100

libedlib (1.2.7-3) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team Upload.
  * Fix version of package in CMakeLists.txt

  [ tony mancill ]
  * Enable building shared libs; upstream defaults this to OFF
    (Closes: #996541)
  * Update symbols file for libedlib1
  * Adjust enabled_shared_and_static.patch
  * Freshen years in debian/copyright
  * Add Build-Depends-Package metadata to libedlib1.symbols (lintian)

 -- tony mancill <tmancill@debian.org>  Wed, 29 Dec 2021 16:18:05 -0800

libedlib (1.2.7-2) unstable; urgency=medium

  * Source-only upload

 -- Andreas Tille <tille@debian.org>  Thu, 14 Oct 2021 09:27:47 +0200

libedlib (1.2.7-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).
  * Apply multi-arch hints.
    + libedlib-dev, libedlib0, python3-edlib: Add Multi-Arch: same.
  * d/watch: Add filemangle
  * Upstream decided to use SOVERSION 1 - so follow this decision
  * Install cmake files

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 15:32:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,28 @@
 Source: libedlib
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
-               dh-python,
+               dh-sequence-python3,
                d-shlibs,
                rename,
                cython3,
                python3-all-dev,
                python3-setuptools
-Standards-Version: 4.5.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libedlib
 Vcs-Git: https://salsa.debian.org/med-team/libedlib.git
 Homepage: https://github.com/Martinsos/edlib
 
-Package: libedlib0
+Package: libedlib1
 Architecture: any
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Multi-Arch: same
 Description: library for sequence alignment using edit distance
  A lightweight and super fast C/C++ library for sequence alignment using
  edit distance.
@@ -53,7 +55,8 @@
 Section: libdevel
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libedlib0 (= ${binary:Version})
+         libedlib1 (= ${binary:Version})
+Multi-Arch: same
 Description: library for sequence alignment using edit distance (devel)
  A lightweight and super fast C/C++ library for sequence alignment using
  edit distance.
@@ -85,7 +88,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libedlib0 (= ${binary:Version})
+         libedlib1 (= ${binary:Version})
 Description: edlib sequence alignment tool using edit distance
  Edlib is a lightweight and super fast C/C++ library for sequence
  alignment using edit distance.  This package provides an aligner
@@ -114,6 +117,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          ${python3:Depends}
+Multi-Arch: same
 Description: library for sequence alignment using edit distance (Python3 module)
  A lightweight and super fast C/C++ library for sequence alignment using
  edit distance.

=== debian/rules ===
--- 
+++ 
@@ -4,12 +4,17 @@
 
 export PYBUILD_NAME = edlib
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto
 
-DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release
+DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release \
+                        -DEDLIB_BUILD_EXAMPLES=False \
+                        -DBUILD_TESTING=False \
+                        -DEDLIB_OMIT_README_RST=1 \
+                        -DBUILD_SHARED_LIBS=ON
+EDLIB_OMIT_README_RST=1
 
 %:
-	dh $@ --with python3
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure --buildsystem=cmake -- $(DEB_CMAKE_EXTRA_FLAGS)
@@ -17,8 +22,8 @@
 override_dh_auto_build:
 	dh_auto_build --buildsystem=cmake
 	# $(MAKE) --directory=bindings/python
-	$(MAKE) --directory=bindings/python edlib pyedlib.bycython.cpp
-	dh_auto_build --buildsystem=pybuild -- --dir bindings/python
+	EDLIB_OMIT_README_RST=1 $(MAKE) --directory=bindings/python edlib pyedlib.bycython.cpp
+	EDLIB_OMIT_README_RST=1 dh_auto_build --buildsystem=pybuild -- --dir bindings/python
 
 override_dh_auto_install:
 	dh_auto_install --buildsystem=cmake
@@ -33,6 +38,7 @@
 		    --devunversioned \
 		    --exclude-la \
 		    --movedev debian/tmp/usr/include/* usr/include \
+		    --movedev debian/tmp/usr/lib/*/cmake usr/lib/$(DEB_HOST_MULTIARCH) \
 		    --movedev debian/tmp/usr/lib/*/pkgconfig usr/lib/$(DEB_HOST_MULTIARCH) \
 		    debian/tmp/usr/lib/*/*.so

=== debian/watch ===
Version: 5

Template: Github
Owner: Martinsos
Project: edlib
